﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Xml.Linq;
using System.Windows.Media.Imaging;

namespace C1Gallery
{
    public partial class MainPage : UserControl
    {
        private string _imageUrl;
        private int _selIndex = 0;
        private List<GalleryImage> _galleryImages;

        public MainPage()
        {
            InitializeComponent();
        }

        public string ImageUrl
        {
            get
            {
                return _imageUrl;
            }
            set
            {
                _imageUrl = value;
            }
        }

        public int SelIndex
        {
            get
            {
                return _selIndex;
            }
            set
            {
                _selIndex = value;
            }
        }

        private void UserControl_Loaded(object sender, RoutedEventArgs e)
        {
            //load xml file
            WebClient wc = new WebClient();
            wc.DownloadStringCompleted += new System.Net.DownloadStringCompletedEventHandler(wc_DownloadStringCompleted);
            wc.DownloadStringAsync(new Uri(ImageUrl, UriKind.RelativeOrAbsolute));
        }

        void wc_DownloadStringCompleted(object sender, System.Net.DownloadStringCompletedEventArgs e)
        {
            if (e.Error == null)
            {
                //load xml to list
                XDocument doc = XDocument.Parse(e.Result);
                _galleryImages = (from image in doc.Descendants("image")
                                  select new GalleryImage
                                  {
                                      Url = image.Element("url").Value
                                  }).ToList();

                //load coverflow
                foreach (GalleryImage gi in _galleryImages)
                {
                    BitmapImage bi = new BitmapImage();
                    bi.UriSource = new Uri(App.Current.Host.Source, gi.Url);
                    c1CoverFlow1.Items.Add(new Image() { Source = bi });
                }
                //set starting index
                c1CoverFlow1.SelectedIndex = SelIndex;
            }
        }
    }

    public class GalleryImage
    {
        public string Url { get; set; }
    }
}
